'use strict';

exports.__esModule = true;

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _stcHelper = require('stc-helper');

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var homePath = process.env[process.platform === 'win32' ? 'USERPROFILE' : 'HOME'];
var tmpPath = _os2.default.tmpdir();
//import stcDepParser from 'stc-dep-parser';
/**
 * config class
 */

var _class = function () {
  /**
   * constructor
   */
  function _class() {
    (0, _classCallCheck3.default)(this, _class);

    /**
     * default config
     */
    this._config = {
      //product: 'default',
      workers: 0,
      cluster: true,
      cache: true,
      cachePath: '', //cache path
      include: '.',
      exclude: '',
      defaultExclude: [/Thumbs\.db$/i, /\.svn|\.git/, /\.DS_Store$/i],
      outputPath: 'output',
      pathHandle: undefined,
      tpl: {
        extname: 'html',
        engine: '',
        adapter: undefined,
        ld: '',
        rd: ''
      },
      jsTpl: {
        type: ['text/html', 'text/template'],
        engine: '',
        adapter: undefined,
        ld: '',
        rd: ''
      },
      dependence: [
        //{plugin: stcDepParser, name: 'defaultDepParser', include: [{type: 'tpl'}]}
      ]
    };
  }
  /**
   * get config
   */


  _class.prototype.get = function get(name) {
    if (!name) {
      return this.parseConfig(this._config);
    }
    return this._config[name];
  };
  /**
   * parse config
   */


  _class.prototype.parseConfig = function parseConfig(config) {
    // verify config.product
    if (!config.product || !/^[\w\.]+$/.test(config.product)) {
      console.error('config.product must be set, pattern is /^[\w\.]+$/');
      process.exit(100);
      return;
    }

    var _config$tpl = config.tpl,
        ld = _config$tpl.ld,
        rd = _config$tpl.rd;

    if (!Array.isArray(ld)) {
      config.tpl.ld = [ld];
    }
    if (!Array.isArray(rd)) {
      config.tpl.rd = [rd];
    }
    // make config.include be array
    if (!Array.isArray(config.include)) {
      config.include = [config.include];
    }
    // for calculate cache key
    config._tplCacheKey = (0, _stringify2.default)(config.tpl) + (0, _stringify2.default)(config.jsTpl);
    config.cachePath = this.getCachePath(config.cachePath);
    return config;
  };
  /**
   * get cache path
   */


  _class.prototype.getCachePath = function getCachePath(cachePath) {
    var list = [_path2.default.join(homePath, '.stc/'), _path2.default.join(tmpPath, '.stc/')];
    if (cachePath) {
      list.unshift(cachePath);
    }
    for (var i = 0, length = list.length; i < length; i++) {
      var item = list[i];
      if ((0, _stcHelper.mkdir)(item)) {
        return item;
      }
    }
  };
  /**
   * set config
   */


  _class.prototype.set = function set(name, value) {
    if ((typeof name === 'undefined' ? 'undefined' : (0, _typeof3.default)(name)) === 'object') {
      this._config = (0, _stcHelper.extend)(this._config, name);
      return this;
    }
    this._config[name] = (0, _stcHelper.extend)(this._config[name], value);
    return this;
  };

  return _class;
}();

exports.default = _class;
//# sourceMappingURL=config.js.map